#include "PlayerAreaModel.h"

PlayerAreaModel::PlayerAreaModel(QObject *parent)
{
    Player defaultValues;

    for(int i = 0; i < 8; i++){
        players.append(defaultValues);
    }
}

uint PlayerAreaModel::focusedPlayer()
{
    return focusedPlayer_;
}

void PlayerAreaModel::setFocusedPlayer(int n)
{
    focusedPlayer_ = n;
    Player player = players.at(n);
    BetType b1 = player.bet1.betType;
    BetType b2 = player.bet2.betType;
    uint n1 = player.bet1.betSpot;
    uint n2 = player.bet2.betSpot;
    emit focusedPlayerChanged(b1, n1, b2, n2);
}

QString PlayerAreaModel::getPlayerName(int n)
{
    return players.at(n).playerName;
}

void PlayerAreaModel::setPlayerName(QString s, int n)
{
    this->players[n].playerName = s;
}

void PlayerAreaModel::bet(BetType b, int n, int bet)
{
    Player *player = &players[focusedPlayer_];

    if (player->bet1.betType == NONE) {
        player->bet1.betType = b;
        player->bet1.betValue = bet;
        player->bet1.betSpot = n;
        if (b == 9 && n <= 35) {
            n = 35 - n;
        }
        emit betChanged(b, n, bet);
    } else if (player->bet2.betType == NONE) {
        player->bet2.betType = b;
        player->bet2.betValue = bet;
        player->bet2.betSpot = n;
        if (b == 9 && n <= 35) {
            n = 35 - n;
        }
        emit betChanged(b, n, bet);
    }
}

void PlayerAreaModel::removeBet(BetType b, int n)
{
    Player *player = &players[focusedPlayer_];
    if (player->bet1.betType != NONE) {
        player->bet1.betType = NONE;
        if (b == 9 && n <= 35) {
            n = 35 - n;
        }
        emit betRemoved(b, n);
    } else {
        player->bet2.betType = NONE;
        if (b == 9 && n <= 35) {
            n = 35 - n;
        }
        emit betRemoved(b, n);
    }
}

void PlayerAreaModel::cancelBet(BetType b, int n)
{
    emit betCanceled(b, n);
}

void PlayerAreaModel::payout()
{
    printf("payout\n");
}
